=== debian/changelog ===
ros-rolling-libg2o (2020.5.29-2focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Tue, 16 Jun 2020 12:58:32 -0000
